//+------------------------------------------------------------------+
//| MultiZigZag                        ZigZag_NK.mq4 |
//+------------------------------------------------------------------+
/*

  14  2008 .


     .
     .

1)   .      High
    Low .     .
           "".
2)     ,     
       .      .
3)   ,    ,
      .

  -  . 
       . 
  -   ,  -  ,  -  .  .   ZUP   . 

   . ,   ,    .


nen
 */
#property link      "nen"
//----     
#property indicator_chart_window
//----   
#property indicator_buffers  6
//----  
#property indicator_color1 Aqua
//#property indicator_color2 Aqua
#property indicator_color3 Red
//#property indicator_color4 Aqua
#property indicator_color5 Yellow
//#property indicator_color6 Aqua
//----   
#property indicator_width1 0
#property indicator_width2 0
#property indicator_width3 0
#property indicator_width4 0
#property indicator_width5 0
#property indicator_width6 0
//----    
#property indicator_style1 0
#property indicator_style2 0
#property indicator_style3 0
#property indicator_style4 0
#property indicator_style5 0
#property indicator_style6 0
//----    
extern string ExtDepth     = "12,34,55";
extern string ExtDeviation = "5,21,34";
extern string ExtBackstep  = "3,55,89";
extern string ExtMaxBar    = "0,0,0";     //    (0-)

//---- 
int ExtDepth1[3], ExtDeviation1[3], ExtBackstep1[3], ExtMaxBar1[3];

//----  
double LowestBuffer1[],HighestBuffer1[],LowestBuffer2[],HighestBuffer2[],LowestBuffer3[],HighestBuffer3[];
//----+           
int    MaxBar[]={0,0,0},time2[]={0,0,0},LASTLOWPOS[]={0,0,0},LASTHIGHPOS[]={0,0,0},LHTIME[]={0,0,0},LLTIME[]={0,0,0};  
//----+             
double LowestMEMORY1[],HighestMEMORY1[],LowestMEMORY2[],HighestMEMORY2[],LowestMEMORY3[],HighestMEMORY3[];
double LASTLOW0[]={0,0,0},LASTLOW1[]={0,0,0},LASTHIGH0[]={0,0,0},LASTHIGH1[]={0,0,0},LASTHIGHEST[]={0,0,0},LASTLOWEST[]={0,0,0};
//----+      lBar, hBar  tiZZ   
//            . 
//        .
double lBar[]={0,0,0}, hBar[]={0,0,0};
datetime tiZZ[]={0,0,0};
//     Bars
int saveBars[]={0,0,0};
bool recalculate;
//+------------------------------------------------------------------+
//| ZigZag initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
   int i,j,k;
//----       
   SetIndexBuffer(0,LowestBuffer1);
   SetIndexBuffer(1,HighestBuffer1);
   SetIndexBuffer(2,LowestBuffer2);
   SetIndexBuffer(3,HighestBuffer2);
   SetIndexBuffer(4,LowestBuffer3);
   SetIndexBuffer(5,HighestBuffer3);
//----      ZigZag 
   SetIndexStyle(0,DRAW_ZIGZAG);
   SetIndexStyle(1,DRAW_ZIGZAG);
   SetIndexStyle(2,DRAW_ZIGZAG);
   SetIndexStyle(3,DRAW_ZIGZAG);
   SetIndexStyle(4,DRAW_ZIGZAG);
   SetIndexStyle(5,DRAW_ZIGZAG);
//----   ,      
   SetIndexEmptyValue(0,0.0);
   SetIndexEmptyValue(1,0.0);
   SetIndexEmptyValue(2,0.0);
   SetIndexEmptyValue(3,0.0);
   SetIndexEmptyValue(4,0.0);
   SetIndexEmptyValue(5,0.0);
//----        
   SetIndexLabel(0,"Low1" );
   SetIndexLabel(1,"High1");
   SetIndexLabel(2,"Low2" );
   SetIndexLabel(3,"High2");
   SetIndexLabel(4,"Low3" );
   SetIndexLabel(5,"High3");

   j=0;k=0;
   for (i=0;i<3;i++)
     {
      j=StringFind(ExtDepth,",",k);
      if (j<0) {ExtDepth1[i]=StrToInteger(StringSubstr(ExtDepth,k)); break;}
      ExtDepth1[i]=StrToInteger(StringSubstr(ExtDepth,k,j-k));
      k=j+1;
     }

   j=0;k=0;
   for (i=0;i<3;i++)
     {
      j=StringFind(ExtDeviation,",",k);
      if (j<0) {ExtDeviation1[i]=StrToInteger(StringSubstr(ExtDeviation,k)); break;}
      ExtDeviation1[i]=StrToInteger(StringSubstr(ExtDeviation,k,j-k));
      k=j+1;
     }

   j=0;k=0;
   for (i=0;i<3;i++)
     {
      j=StringFind(ExtBackstep,",",k);
      if (j<0) {ExtBackstep1[i]=StrToInteger(StringSubstr(ExtBackstep,k)); break;}
      ExtBackstep1[i]=StrToInteger(StringSubstr(ExtBackstep,k,j-k));
      k=j+1;
     }

   j=0;k=0;
   for (i=0;i<3;i++)
     {
      j=StringFind(ExtMaxBar,",",k);
      if (j<0) {ExtMaxBar1[i]=StrToInteger(StringSubstr(ExtMaxBar,k)); break;}
      ExtMaxBar1[i]=StrToInteger(StringSubstr(ExtMaxBar,k,j-k));
      k=j+1;
     }

//----     
//   size=ExtBackstep+1;
//----     
   ArrayResize(LowestMEMORY1,ExtBackstep1[0]+1);
   ArrayResize(HighestMEMORY1,ExtBackstep1[0]+1);
   ArrayResize(LowestMEMORY2,ExtBackstep1[1]+1);
   ArrayResize(HighestMEMORY2,ExtBackstep1[1]+1);
   ArrayResize(LowestMEMORY3,ExtBackstep1[2]+1);
   ArrayResize(HighestMEMORY3,ExtBackstep1[2]+1);

//   IndicatorShortName("ZigZag (ExtDepth="+ExtDepth+", ExtDeviation="+ExtDeviation+", ExtBackstep="+ExtBackstep+" )");


   for (i=0;i<3;i++)
     {
      if (ExtMaxBar1[i]>iBars(NULL,Period())-ExtDepth1[0] || ExtMaxBar1[i]==0) MaxBar[i]=iBars(NULL,Period())-ExtDepth1[i]; else MaxBar[i]=ExtMaxBar1[i];
      saveBars[i]=0;
     }
//----  

   return(0);
  }


int start()
  {
   int i,lim=0;
   bool calculate;

   for (i=0;i<3;i++)
     {
      //----+         
      if (iBars(NULL,Period())-1<ExtDepth1[i]) continue;
      calculate=false;

      if (iBars(NULL,Period())-saveBars[i]-1>2)
        {
         recalculate=true;
         calculate=true;

         switch(i)
           {
            case 0: {ArrayInitialize(LowestBuffer1,0); ArrayInitialize(HighestBuffer1,0);}
            case 1: {ArrayInitialize(LowestBuffer2,0); ArrayInitialize(HighestBuffer2,0);}
            case 2: {ArrayInitialize(LowestBuffer3,0); ArrayInitialize(HighestBuffer3,0);}
           }
         if (ExtMaxBar1[i]>iBars(NULL,Period())-ExtDepth1[i] || ExtMaxBar1[i]==0) MaxBar[i]=iBars(NULL,Period())- ExtDepth1[i];
         lim=MaxBar[i];
        }
      else
        {
         recalculate=false;

         if (lBar[i]>iLow(NULL,Period(),0) || hBar[i]<iHigh(NULL,Period(),0) || tiZZ[i]!=iTime(NULL,Period(),0))
           {
            calculate=true;
            lim=iBars(NULL,Period())-saveBars[i]-1;
            saveBars[i]=iBars(NULL,Period());
           }
        }

      if (calculate)
        {
         switch(i)
           {
            case 0: ZigZag_NK_(ExtDepth1[i], ExtDeviation1[i], ExtBackstep1[i], LowestBuffer1, HighestBuffer1, time2[i], LLTIME[i], LHTIME[i],
                 LowestMEMORY1, HighestMEMORY1, LASTLOW0[i], LASTLOW1[i], LASTHIGH0[i], LASTHIGH1[i], LASTLOWEST[i], LASTHIGHEST[i], recalculate, lim);
            case 1: ZigZag_NK_(ExtDepth1[i], ExtDeviation1[i], ExtBackstep1[i], LowestBuffer2, HighestBuffer2, time2[i], LLTIME[i], LHTIME[i],
                 LowestMEMORY2, HighestMEMORY2, LASTLOW0[i], LASTLOW1[i], LASTHIGH0[i], LASTHIGH1[i], LASTLOWEST[i], LASTHIGHEST[i], recalculate, lim);
            case 2: ZigZag_NK_(ExtDepth1[i], ExtDeviation1[i], ExtBackstep1[i], LowestBuffer3, HighestBuffer3, time2[i], LLTIME[i], LHTIME[i],
                 LowestMEMORY3, HighestMEMORY3, LASTLOW0[i], LASTLOW1[i], LASTHIGH0[i], LASTHIGH1[i], LASTLOWEST[i], LASTHIGHEST[i], recalculate, lim);
           }

          lBar[i]=iLow(NULL,Period(),0); hBar[i]=iHigh(NULL,Period(),0); tiZZ[i]=iTime(NULL,Period(),0);
         }
     }

   return(0);
  }


//+------------------------------------------------------------------+
//|  ZigZag iteration function                                       |
//+------------------------------------------------------------------+

void ZigZag_NK_(int Depth,int Deviation,int Backstep,double& LB[],double& HB[],int time2,int LLT,int LHT,
                double& LM[],double& HM[],double LL0,double LL1,double LH0,double LH1,double LL,double LH,bool recalc,int limit)
  {
   //----+    
   int iii,j;
   //----+      
   int    bar,back,lasthighpos,lastlowpos;
   double curlow,curhigh,lasthigh0,lastlow0,lasthigh1,lastlow1,val,res;

   if (recalc)
     {
      lastlow1=-1; 
      lasthigh1=-1; 
      lastlowpos=-1; 
      lasthighpos=-1;
     }
        
   //+---    +======+
   if (limit<=2)
    {
     if (time2==iTime(NULL,Period(),limit+1))
      {
       lastlow0=LL0;
       lasthigh0=LH0;
       //+---
       lastlow1=LL1;
       lasthigh1=LH1;
       //+---
       lastlowpos=iBarShift(NULL,Period(),LLT,true); 
       lasthighpos=iBarShift(NULL,Period(),LHT,true); 
       //+---   lasthighpos  lastlowpos     
       if ((lasthighpos<0)||(lastlowpos<0))
        {
         return(-1);
        }
       //+---
       LB[lastlowpos]=LL;
       HB[lasthighpos]=LH;
       //+---     
       for(iii=Backstep; iii>=0; iii--)
        {
         LB[iii+limit+1]=LM[iii];
         HB[iii+limit+1]=HM[iii];
        }
       //+---    
      } 
     else 
      {
       return(-1);  
      }
    }

   //----+ ---------- <<<     >>> -----------+  
   for(bar=limit; bar>=0; bar--)
     {
      //+---    +=========+ 
      if (bar==1)
        {
         if(((limit==1)&&(time2==iTime(NULL,Period(),2)))||(limit>1))
          {
           LL0=lastlow0;
           LH0=lasthigh0;
           //+---
           for(iii=Backstep; iii>=0; iii--)
            {
             LM[iii]=LB[iii+2];
             HM[iii]=HB[iii+2];
            }
          }
        }
      //+---+=========================================+     
  
      //--- low
      j=iLowest(NULL,0,MODE_LOW,Depth,bar);
      val=iLow(NULL,Period(),j);
      if(val==lastlow0) val=0.0;
      else 
        { 
         lastlow0=val; 
         if((iLow(NULL,Period(),bar)-val)>(Deviation*Point))val=0.0;
         else
           {
            for(back=1; back<=Backstep; back++)
              {
               res=LB[j+back];
               if(res>val)LB[j+back]=0.0; 
              }
           }
        } 
      if (j==bar) LB[j]=val;
      //--- high
      j=iHighest(NULL,0,MODE_HIGH,Depth,bar);
      val=iHigh(NULL,Period(),j);
      if(val==lasthigh0) val=0.0;
      else 
        {
         lasthigh0=val;
         if((val-iHigh(NULL,Period(),bar))>(Deviation*Point))val=0.0;
         else
           {
            for(back=1; back<=Backstep; back++)
              {
               res=HB[j+back];
               if(res<val)HB[j+back]=0.0; 
              } 
           }
        }
      if (j==bar) HB[j]=val;
     }
    //----+     
   
   //----+ ---------- <<<     >>> -----------+  
   for(bar=limit; bar>=0; bar--)
     {
      //+---    +====+ 
      if (bar==1)
       {
        if(((limit==1)&&(time2==iTime(NULL,Period(),2)))||(limit>1))
         {
          time2=iTime(NULL,Period(),2);
          LL1=lastlow1;
          LH1=lasthigh1;
          //+---
          LLT=iTime(NULL,Period(),lastlowpos);
          LHT=iTime(NULL,Period(),lasthighpos);
          //+---
          LL=LB[lastlowpos];
          LH=HB[lasthighpos];
         }
       }
     //+---+====================================+     
     
      curlow=LB[bar];
      curhigh=HB[bar];
      //---
      if((curlow==0)&&(curhigh==0))continue;
      //---
      if(curhigh!=0)
        {
         if(lasthigh1>0) 
           {
            if(lasthigh1<curhigh) HB[lasthighpos]=0;
            else HB[bar]=0;
           }
         //---
         if(lasthigh1<curhigh || lasthigh1<0)
           {
            lasthigh1=curhigh;
            lasthighpos=bar;
           }
         lastlow1=-1;
        }
      //----
      if(curlow!=0)
        {
         if(lastlow1>0)
           {
            if(lastlow1>curlow) LB[lastlowpos]=0;
            else LB[bar]=0;
           }
         //---
         if((curlow<lastlow1)||(lastlow1<0))
           {
            lastlow1=curlow;
            lastlowpos=bar;
           } 
         lasthigh1=-1;
        }
     } 
   //----+     
   //+-----------------------------------------------------------------+ 
        
 //----    
   return(0);
}
//+---------------------------------------------------------------------------+

